//http://www.edaboard.com/thread289261.html

#define POWER_SUPPLY "5V"
#define FOSC_INTERNE
#define FOSC "16MHz"
#define BAUD "19200"  // UART1
#define LANGAGE " Mikroc V 7.60"


#define With_UART1
// UART RC6 =TX=fil blanc   RC7= RX=fil vert  Interface Prolific LTTL/USB  -> COM12 19200  ->YAT terminal

// 27-12-2019
// Test  with PIC18F26K22 and use of PORTC to drive AD9850
// Test OK to drive AD9850 with PORTC *  isolate trouh 1K resistor from ICSP !!
//  tester avec Oscilloscope , car aucune sortie sur RS232
// ou mettre R=1K Led sur sortie SQUARE...pin 7 ou 8 AD9850

// #define RESET_AD9850 LATBbits.LATB4 // Reset line NOT USED ..direct to Gnd
//#define AD9850_CONTROL_WORD 0x00 // 8 Byte zerosconstante replaced by variable
//#define AD9850_FREQUENCY 1000.0 //  constant replaced by variable
//#define AD9850_FREQUENCY_FACTOR 34.35973837 // replaced by variable



#include "built_in.h"     // for  Hi  Lo ..etc

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space
#define ON 0
#define OFF 1
#define Byte unsigned char        // Define CHAR as Byte data type

int i,j,k,l,m,n;
unsigned  char TEXTE[80]; // pour teste quelconque
char CRam1[64];

sbit Led_Rouge at LATA.B4;
sbit Led_Rouge_Direction  at TRISA4_bit;

//test with PORTC
sbit  W_CLCK  at LATC.B3;   // Clock line to clock in data --> 2 of AD9850 HCV-SR08
sbit  FQ_UD   at LATC.B5 ;    // Frequency up date line ---> 3 of AD9850 HCV-SR08
sbit  SData   at LATC.B4;     // Serial data line ---> 4 of AD9850 HCV-SR08
sbit  W_CLK_Dir at TRISC.B3;
sbit  FQ_UD_Dir at TRISC.B5;
sbit  SData_Dir at TRISC.B4;

struct DataBytes
{
 Byte pv0;
 Byte pv1;
 Byte pv2;
 Byte pv3;
};

union
{
 unsigned long TuningWord;
 struct  DataBytes DDS;
}AD9850_Serial_Data;

unsigned char AD9850_CONTROL_WORD;
float AD9850_FREQUENCY =1000.0 ;  // 1KHz
float AD9850_FREQUENCY_FACTOR = 34.35973837; // 2^32 divided by 125MHz

/*---------------------------------------
Prototype declerations of the functions
----------------------------------------*/

void Init_AD9850(void);
void SendSerialDataByteToAD9850(unsigned char Data);
void AD9850_Charge_Freq(float Freq);
void FRQ_UD_AD9850(void);


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}


void Init_Hardware()
{
  PORTA = 0b00010011;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELA.ANSA1=1;
  TRISA = 0b00001111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3  RA4=Input  RA5,6=Digital output
  Led_Rouge_Direction=0;
  Led_Rouge=OFF;

  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1

  W_CLK_Dir=0;  // RC3
  FQ_UD_Dir=0;  // RC5
  SData_Dir=0;  //RC4
  W_CLCK=0;
  FQ_UD=0;
  SData=0;

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }

void Delay_Xsec(char Nb)
{ 
  int i;
 for (i=0;i<Nb;i++)
 {
   Delay_1sec();
  }
}


void Init_AD9850(void)
{
Byte counter;
SData=0;
W_CLCK=0;
FQ_UD=0;
//Reset address pointer to W0 (first word) in AD9850
FQ_UD = 1;
Delay_us(100);
Delay_us(100);
FQ_UD = 0;
Delay_us(100);

W_CLCK = 1;         //1ere
Delay_us(100);
W_CLCK = 0;
Delay_us(100);

//Enable serial mode
FQ_UD = 1;
Delay_us(100);
Delay_us(100);
FQ_UD = 0;
Delay_us(100);

// Following loop sends zero three times to AD9850 as W32=0,W33=0 & W34=0
counter=0;

do
{
SData = 0;
W_CLCK = 1;
Delay_us(100);
W_CLCK = 0;
Delay_us(100);
counter++;
}while (counter<3);
//Reset the control word pointer to W0 in AD9850
FQ_UD = 1;
Delay_us(100);
Delay_us(100);
FQ_UD = 0;
Delay_us(100);
}

/*--------------------------------------------------------------------------------------------
AD9850_Charge_Freq FUNCTION DEFINATION
---------------------------------------------------------------------------------------------*/

void AD9850_Charge_Freq(float Freq)
{
AD9850_Serial_Data.TuningWord = (long) (Freq * AD9850_FREQUENCY_FACTOR);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv0);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv1);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv2);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv3);
SendSerialDataByteToAD9850(AD9850_CONTROL_WORD);
Delay_us(100);
FQ_UD = 1;
Delay_us(200);
FQ_UD = 0;
Delay_us(200);
}


/*--------------------------------------------------------------------------------------------
SendSerialDataByteToAD9850 FUNCTION DEFINATION
---------------------------------------------------------------------------------------------*/

void SendSerialDataByteToAD9850(unsigned char Donnee)
{
Byte counter = 0;
do
{
SData = 0;
if(Donnee & 0x01) SData=1; // Check LSB bit
Donnee = Donnee>>1; // RIGHT SHIFT THE Donnee BY ONE BIT
W_CLCK = 1;
Delay_us(100);
W_CLCK = 0;
Delay_us(100);
counter++;
}while(counter<8);

}

void main()
{
#ifdef FOSC_INTERNE
  // OSCCON = 0b01110000  ; //0x70 Oscillateur  16Mhz x 4 avec PLL=1
  //OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz  No PLL
  //OSCTUNE.PLLEN=0
  OSCTUNE=0;
  OSCCON = 0b01110010  ; //0x72 Oscillateur  16Mhz avec PLL=0
 // OSCTUNE.PLLEN=1;
  OSCCON2=0;
  while (OSCCON.HFIOFS==0); // wait stable oscillator
 #endif


  Init_Hardware() ;
  UART1_Init(19200);
  Delay_ms(1000);
   UART1_Write_CText("Test AD9850  avec PIC18F26K22 16MHz  \r\n");

  AD9850_CONTROL_WORD = 0; //initialize control word
  SData=0;
  W_CLCK=0;
  FQ_UD=0;
  // stabilisation delay for power up both PIC & AD9850
  Delay_1sec();

  AD9850_FREQUENCY =1000.0 ;  // 1KHz
  AD9850_FREQUENCY_FACTOR = 34.35973837; // 2^32 divided by 125MHz
  Init_AD9850();
  Delay_ms(100);

   UART1_Write_CText("Test en mode detaill , envoi byte par byte \r\n");

  AD9850_Serial_Data.TuningWord=34360;   // pour 1000 Hz
  SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv0);
  SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv1);
  SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv2);
  SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv3);
  SendSerialDataByteToAD9850(AD9850_CONTROL_WORD);
  Delay_us(100);
  FQ_UD = 1;
  Delay_us(100);
  FQ_UD = 0;
  Delay_Xsec(4);

do
{
  UART1_Write_CText(" Init  1Hz \r\n");
  AD9850_FREQUENCY =1.0 ;  // 1Hz
  AD9850_Charge_Freq(AD9850_FREQUENCY);
  Delay_Xsec(5);
   UART1_Write_CText(" Init  1000Hz \r\n");
  AD9850_FREQUENCY =1000.0 ;  // 1KHz
  AD9850_Charge_Freq(AD9850_FREQUENCY);
  Delay_Xsec(5);
   UART1_Write_CText(" Init  5000Hz \r\n");
  AD9850_FREQUENCY =5000.0 ;  // 5KHz
  AD9850_Charge_Freq(AD9850_FREQUENCY);
  Delay_Xsec(5);
   UART1_Write_CText(" Init  20KHz \r\n");
  AD9850_FREQUENCY =20000.0 ;
  AD9850_Charge_Freq(AD9850_FREQUENCY);
  Delay_Xsec(5);
   UART1_Write_CText(" Init  200KHz \r\n");
  AD9850_FREQUENCY =200000.0 ;
  AD9850_Charge_Freq(AD9850_FREQUENCY);
  Delay_Xsec(5);
   UART1_Write_CText(" Init  1 MHz \r\n");
  AD9850_FREQUENCY =1000000.0 ;
  AD9850_Charge_Freq(AD9850_FREQUENCY);
  Delay_Xsec(5);
}
while(1);
}



