#line 1 "C:/_MikroC/_MesProjets_MikroC/_18Fx6K22_DDS/PIC18F26K22_AD9850_DDS_test_2019.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 38 "C:/_MikroC/_MesProjets_MikroC/_18Fx6K22_DDS/PIC18F26K22_AD9850_DDS_test_2019.c"
int i,j,k,l,m,n;
unsigned char TEXTE[80];
char CRam1[64];

sbit Led_Rouge at LATA.B4;
sbit Led_Rouge_Direction at TRISA4_bit;


sbit W_CLCK at LATC.B3;
sbit FQ_UD at LATC.B5 ;
sbit SData at LATC.B4;
sbit W_CLK_Dir at TRISC.B3;
sbit FQ_UD_Dir at TRISC.B5;
sbit SData_Dir at TRISC.B4;

struct DataBytes
{
  unsigned char  pv0;
  unsigned char  pv1;
  unsigned char  pv2;
  unsigned char  pv3;
};

union
{
 unsigned long TuningWord;
 struct DataBytes DDS;
}AD9850_Serial_Data;

unsigned char AD9850_CONTROL_WORD;
float AD9850_FREQUENCY =1000.0 ;
float AD9850_FREQUENCY_FACTOR = 34.35973837;
#line 75 "C:/_MikroC/_MesProjets_MikroC/_18Fx6K22_DDS/PIC18F26K22_AD9850_DDS_test_2019.c"
void Init_AD9850(void);
void SendSerialDataByteToAD9850(unsigned char Data);
void AD9850_Charge_Freq(float Freq);
void FRQ_UD_AD9850(void);



void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

void UART1_Write_CText(const char *txt)
 {
 while (*txt)
 UART1_Write(*txt++);
}


void Init_Hardware()
{
 PORTA = 0b00010011;
 ANSELA=0;
 ANSELA.ANSA0=1;
 ANSELA.ANSA1=1;
 TRISA = 0b00001111 ;
 Led_Rouge_Direction=0;
 Led_Rouge= 1 ;

 PORTB = 0xFF;
 TRISB = 0x83;
 ANSELB=0;

 PORTC = 0x00;
 ANSELC=0;
 TRISC = 0xFF;
 TRISC.TRISC7 = 1;
 TRISC.TRISC6 = 0;

 W_CLK_Dir=0;
 FQ_UD_Dir=0;
 SData_Dir=0;
 W_CLCK=0;
 FQ_UD=0;
 SData=0;

 SLRCON=0;
 }

void Delay_Xsec(char Nb)
{
 int i;
 for (i=0;i<Nb;i++)
 {
 Delay_1sec();
 }
}


void Init_AD9850(void)
{
 unsigned char  counter;
SData=0;
W_CLCK=0;
FQ_UD=0;

FQ_UD = 1;
Delay_us(100);
Delay_us(100);
FQ_UD = 0;
Delay_us(100);

W_CLCK = 1;
Delay_us(100);
W_CLCK = 0;
Delay_us(100);


FQ_UD = 1;
Delay_us(100);
Delay_us(100);
FQ_UD = 0;
Delay_us(100);


counter=0;

do
{
SData = 0;
W_CLCK = 1;
Delay_us(100);
W_CLCK = 0;
Delay_us(100);
counter++;
}while (counter<3);

FQ_UD = 1;
Delay_us(100);
Delay_us(100);
FQ_UD = 0;
Delay_us(100);
}
#line 190 "C:/_MikroC/_MesProjets_MikroC/_18Fx6K22_DDS/PIC18F26K22_AD9850_DDS_test_2019.c"
void AD9850_Charge_Freq(float Freq)
{
AD9850_Serial_Data.TuningWord = (long) (Freq * AD9850_FREQUENCY_FACTOR);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv0);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv1);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv2);
SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv3);
SendSerialDataByteToAD9850(AD9850_CONTROL_WORD);
Delay_us(100);
FQ_UD = 1;
Delay_us(200);
FQ_UD = 0;
Delay_us(200);
}
#line 210 "C:/_MikroC/_MesProjets_MikroC/_18Fx6K22_DDS/PIC18F26K22_AD9850_DDS_test_2019.c"
void SendSerialDataByteToAD9850(unsigned char Donnee)
{
 unsigned char  counter = 0;
do
{
SData = 0;
if(Donnee & 0x01) SData=1;
Donnee = Donnee>>1;
W_CLCK = 1;
Delay_us(100);
W_CLCK = 0;
Delay_us(100);
counter++;
}while(counter<8);

}

void main()
{




 OSCTUNE=0;
 OSCCON = 0b01110010 ;

 OSCCON2=0;
 while (OSCCON.HFIOFS==0);



 Init_Hardware() ;
 UART1_Init(19200);
 Delay_ms(1000);
 UART1_Write_CText("Test AD9850  avec PIC18F26K22 16MHz  \r\n");

 AD9850_CONTROL_WORD = 0;
 SData=0;
 W_CLCK=0;
 FQ_UD=0;

 Delay_1sec();

 AD9850_FREQUENCY =1000.0 ;
 AD9850_FREQUENCY_FACTOR = 34.35973837;
 Init_AD9850();
 Delay_ms(100);

 UART1_Write_CText("Test en mode detaill , envoi byte par byte \r\n");

 AD9850_Serial_Data.TuningWord=34360;
 SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv0);
 SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv1);
 SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv2);
 SendSerialDataByteToAD9850(AD9850_Serial_Data.DDS. pv3);
 SendSerialDataByteToAD9850(AD9850_CONTROL_WORD);
 Delay_us(100);
 FQ_UD = 1;
 Delay_us(100);
 FQ_UD = 0;
 Delay_Xsec(4);

do
{
 UART1_Write_CText(" Init  1Hz \r\n");
 AD9850_FREQUENCY =1.0 ;
 AD9850_Charge_Freq(AD9850_FREQUENCY);
 Delay_Xsec(5);
 UART1_Write_CText(" Init  1000Hz \r\n");
 AD9850_FREQUENCY =1000.0 ;
 AD9850_Charge_Freq(AD9850_FREQUENCY);
 Delay_Xsec(5);
 UART1_Write_CText(" Init  5000Hz \r\n");
 AD9850_FREQUENCY =5000.0 ;
 AD9850_Charge_Freq(AD9850_FREQUENCY);
 Delay_Xsec(5);
 UART1_Write_CText(" Init  20KHz \r\n");
 AD9850_FREQUENCY =20000.0 ;
 AD9850_Charge_Freq(AD9850_FREQUENCY);
 Delay_Xsec(5);
 UART1_Write_CText(" Init  200KHz \r\n");
 AD9850_FREQUENCY =200000.0 ;
 AD9850_Charge_Freq(AD9850_FREQUENCY);
 Delay_Xsec(5);
 UART1_Write_CText(" Init  1 MHz \r\n");
 AD9850_FREQUENCY =1000000.0 ;
 AD9850_Charge_Freq(AD9850_FREQUENCY);
 Delay_Xsec(5);
}
while(1);
}
